%% DT_T2_d1.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #2
% Demo 1
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Pkomponenttianalyysi / Principal Component Analysis
%
% Vertaa tt demoa paperiharjoitusten tehtvn H2/1.

%% Data:
X  = [2 5 6 7; 1 3 5 7]

% Keskiarvo:
ka = mean(X, 2)

% Keskiarvoistettu data:
XK = X - repmat(ka, 1, 4)

%% Datan kovarianssimatriisi C:
C  =  (1/4)*XK*XK'

%% Kovarianssimatriisin C ominaisarvot ja -vektorit
[V, D]   = eig(C);
lambda_1 = D(2,2)
u_1      = V(:,2)
lambda_2 = D(1,1)
u_2      = V(:,1)

%% Ominaisvektorien pistetulo
% Pistetulo osoittaa, ett ominaisvektorit ovat 
%  kohtisuorassa toisiaan; 
%  nin siis kun vektoreille x ja y: x^T y = 0
u_1'*u_2

%% Projektiot
% PCA_1:n suoralle u_1
Y_pca1 = V(:,2)' * XK
% PCA_2:n suoralle u_2
Y_pca2 = V(:,1)' * XK
% Molempien virittmlle tasolle
Y_pca12 = V(:,[2 1])' * XK

%% Muuttujien lineaariset korrelaatiot
% XK:
XK_corr      = corr(XK')
% Y_pca12:
Y_pca12_corr = corr(Y_pca12')  % PCA: dekorrelointi

%% Varianssit
% x:n suuntaan
XK_1_var   = var(XK(1,:))
% y:n suuntaan
XK_2_var   = var(XK(2,:))
% PCA_1:n suuntaan
Y_pca1_var = var(Y_pca1)           % PCA: varianssin maksimointi
% PCA_2:n suuntaan
Y_pca2_var = var(Y_pca2)

% varianssin kokonaismr
XK_totalVar  = XK_1_var + XK_2_var
Y_totalVar   = Y_pca1_var + Y_pca2_var

%% Rekonstruktiot
% pelkst PCA_1:n projektiosta
XK_pca1 = V(:,2) * Y_pca1
% pelkst PCA_2:n projektiosta
XK_pca2 = V(:,1) * Y_pca2
% molempien PCA_1 ja PCA_2:n projektiosta
XK_pca12 = V * [Y_pca2; Y_pca1]
% alkuperinen data
XK

%% PCA siis
%
% - dekorreloi
% - kiert koordinaatistoa
% - lyt 1. pkomponentin suunnassa datan suurimman 
%    vaihtelun (varianssin)
%
% -> esim. dimension pudotus
