%% DT_T2_d3.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #2
% Demo 3
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Tehtv:
% #1 Tee PCA kasvokuvadatalle 
%    (katso kohta "KOODAA THN #1")
% #2 Projisoi kasvokuvat dimensioon 2 xy-tasolle 
%    (katso kohta "KOODAA THN #2")

%% Ominaiskasvot
% Luentojen luku 4, PCA: "eigenfaces". Paperilaskarit H2.
%
% Datana kasvokuvia, jotka luetaan matriisiksi X,
% jossa sarakkeeksi tulee yksi kuva "skannattuna".
% Esim. 10 kuvasta, joiden koko 50x50 pikseli,
% tulisi 2500 rivi ja 10 saraketta.
% Todellisemmassa esimerkiss kuvan koko 2048 x 1536,
% jolloin rivej (dimensio) olisi 3145728.

%% Kuvakokoelma
% Kytetn MIT:n CBCL-kuvatietokantaa. Kts.
% |http://cbcl.mit.edu/cbcl/software-datasets/FaceData2.html|
%
% Kukin kasvokuva on 19 x 19 pikseli, tst tulee
% datavektorin dimensioksi (rivimrksi) 361. 
%
% HUOM! Voit valita mys jonkun muun tiedoston hakemistosta
% |http://www.cis.hut.fi/Opinnot/T-61.2010/Harjoitustyo/|
% kohdasta "Aihe #1". Tllin joudut kuitenkin tekemn
% datan muutokset itse seuraavassa kohdassa.

load DT_T2_K.mat
% sislt muuttujan K

%% Piirretn kasvokuvat
% Kytetn apufunktiota myMontage.m ja
% piirretn kuvat ikkunaan 231.

myMontage(K, 'Kasvokuvat', 231);

%% Muutetaan datamatriisiksi
%
% Tss muokataan kuvamatriisin alkiot oikeaksi 
% datamatriisiksi X ja pakotetaan tyyppi double-tyyppiseksi. 
% Esim. help reshape, help double. Voi kytt mys
% funktiota myK2X.m
%
% Aikaa ja vaivaa sstksemme, lataa valmiiksi 
% skannattu matriisi X, jossa lisksi tehty esiksittelyn 
% jokaisesta kuvasta sen harmaasvyn keskiarvo pois.
% Yritetn tasoittaa kuvausolosuhteita.

load DT_T2_X.mat
% sislt muuttujan X  (361 rivi==pikseli, N saraketta==kuvaa)

%% Varmistetaan K:n ja X:n koko
% K on kuvamatriisi dimensioissa (r x c x 1 x n)
% ja X datamatriisi (rc x n)
%
% Siten seuraavien alkioiden mrien pit olla samat.

disp(['K:n alkioiden lkm: ' num2str(prod(size(K)))]);
disp('K:n dimensiot:');
disp(size(K))

disp(['X:n alkioiden lkm: ' num2str(prod(size(X)))]);    
disp('X:n dimensiot:');
disp(size(X))

%% Tehdn PCA datalle
% 
% Katso esim. demo 2:
%   (1) poistetaan keskiarvo, 
%   (2) lasketaan kovarianssimatriisi 
%   (3) lasketaan sen ominaisarvot ja -vektorit.

% CODE HERE #1. KOODAA THN #1 


%% Piirretn ominaiskasvot
%
% Ominaiskasvot ovat siis matriisin V (koko 361x361)
% pystyvektorit. Nit on 361 kpl, mutta ensimmiset 92 kpl
% (kuvien lkm) on nollasta poikkeavia. 
%
% Jos haluat nhd ominaiskasvokuvat (valmiina luentokalvoissa)
% - F  = V(:, 1:92);
% - KF = myX2K(F, 19, 19, 92);
% - myMontage(KF);

%% Projektion lasku 2D:en
%
% Katso esim. demo 1 tai demo 2 (vaihe projektio).
%
% Projisoidaan kasvokuvat 2D:en eli PCA1:n ja PCA2:n 
% virittmn tasoon (matriisi Y), Y = W^T X.
% Huomaa matriisien koko: Tss X on 361x92.
% Yksi ominaisvektori on 361x1, kaksi 361x2.
% Mill matriisioperaatiolla saadaan Y, joka on 2x92?

% Laske thn projektio rivin "Y = [];" *tilalle*:
% CODE HERE #2. KOODAA THN #2 
Y = []; 

%% Selittvyysaste

selittavyys = 100 *  sum(D(:,1:2)) / sum(diag(D));  % jos suuruusjrj.
%selittavyys = 100 *  sum(D(:,end-1:end)) / sum(diag(D)); % jos pienuusj.

%% Projektion piirtminen 2D:en
%
% HUOM! Piirros vain 2D-Y:lle
if (size(Y,1) ~= 2), 
    warning('Piirros vain 2D-datalle'); 
    figure(232); clf;
else
    figure(232); clf;
    for k=[1:size(Y,2)]
        plot(Y(1,k), Y(2,k), 'bx');
        hold on;
        ti = text(Y(1,k),Y(2,k),[num2str(k)]);
        set(ti,'Color',[0 0 1]);
    end;
    grid on;
    title(['Kasvokuvien projektio 2D:en (' num2str(sum(selittavyys)) '%)']);
end;

%% Tarkastelua ja listehtvi
%
% 1. Ovatko samat kasvot lhekkin toisiaan 2D:ss?
% 2. Ovatko jotkut eri kasvot lhekkin toisiaan 2D:ss? Miksi?
% 3. Kuinka paljon datan vaihtelusta voitiin selitt 2 PCA-komponentilla?
%    Milloin vaihtelusta selittyy 100%?
%

%% xy-tason pisteiden palauttaminen kasvokuviksi
%
% Palautetaan 2-ulotteisen pisteet 361-ulotteisiksi pisteiksi,
% jotka voidaan tulkita 19x19-kuvina. Nhdn kuinka hyvin
% voidaan kuvat pakata kytten vain 2 pkomponenttia.
%
% - knteisprojektio: Xhattu = W * Y
% - Khattu = myX2K(Xhattu, 19, 19, 92);
% - myMontage(Khattu)

%% Tarkastelua ja listehtvi
% *PCA-harjoitusty:
% 4*. Kuinka monta eri kuvaa voidaan saada 19x19-harmaasvykuvasta,
%     jossa 256 tasoa?
% 5*. Milt ominaiskasvot nyttvt?
%     K_omkasvot = myX2K(V(:,1:92),19,19,92);
% 6*. Tiedon pakkaaminen ja purkaminen: 
%    Projektiopisteet Y sek ensimmiset 
%    2 PCA-vektoria (ominaiskuvaa) talletetaan tiedostoon / 
%    lheten siirtotiess vastaanottajalle. Minklaiset
%    kuvat vastaanottaja saa nill purettua?
%    Palautus Xhattu pit olla 361x92. Mill operaatiolla
%    projektiopisteist Y (2x92) ja kannasta W (361x2)?
%     K_pakatut = myX2K(Xhattu, 19,19,92);
% 7*. Muiden kuin kasvokuvien projisoituminen thn kantaan?   
